/* Written by Jan Wigginton */
 
#ifndef CHARTLINE_H
#define CHARTLINE_H

#include "PDFpage.h"
#include "PDFchartmarker.h"
#include "PDFchartobject.h"

class PDFChartLine : public PDFChartObject
  {
  friend class PDFLineChart;
  friend class PDFChartBasics;
  friend class PDFHistogram;
  friend class PDFChartLegend;

  public:

     PDFChartLine();
     virtual ~PDFChartLine();

  private:

     PDFDataMarker   marker;
     double       line_weight;
     PDFLineStyle line_style;

      bool    hasMarkers;
      bool    showLine;
      bool    skipSeries;

     void operator=(const PDFChartLine & rhs);

     void SetMarkerColor(double marker_red, double marker_green, double marker_blue);
     void SetMarkerShape(PDFMarkerShapes marker_shape);
     void SetMarkerRadius(double marker_radius);

     void SetShowLine(bool show_line);
     void SetShowMarker(bool show_marker);

     void SetStyle(PDFLineStyle style);
     void SetWeight(double weight);

     void InitializeMarker(int i);
     void InitializeStyle(int i);

     virtual void SelectColorPen(PDF & pdf);
     virtual void SelectGrayPen(PDF & pdf);

     virtual void DrawMarkerAt(PDF & pdf, double x, double y) { marker.DrawAt(pdf, x, y); }

  };

#endif
 
 
 
 
 
 
 
