/* Written by Jan Wigginton */
 
#ifndef __CHARTOBJECT_H__
#define __CHARTOBJECT_H__

#include "PDFpage.h"

class PDFChartBar;
class PDFChartLine;

class PDFChartObject
   {
   friend class PDFLineChart;
   friend class PDFHistogram;
   friend class PDFChartBasics;
   friend class PDFChartLegend;

   public:

      PDFChartObject();
      virtual ~PDFChartObject();

      // settings

      void SetGray(double line_gray);
      void SetColor(double object_red, double object_green, double object_blue);

      void SelectColorBrush(PDF & pdf);
      void SelectGrayBrush(PDF & pdf);
      virtual void SelectColorPen(PDF & pdf);
      virtual void SelectGrayPen(PDF & pdf);

   protected:

      double  red, green, blue;
      double  gray;
      bool    isInitialized;

      void InitializeGray(int i);
      void InitializeColor(int i);
   };


#endif

 
 
 
 
 
 
 
