// MemoryEstimator.cpp
// Written by Jan Wigginton

#include "MemoryEstimator.h"
#include "MathMatrix.h"
#include "StringArray.h"
#include "IntArray.h"
#include "StringMap.h"
#include <string.h>

double MemoryEstimator::MemoryForMatrix(int n_rows, int n_cols)
   {
   return sizeof(Matrix) + n_cols * (sizeof(ColumnExtras) + 8 * sizeof(char))
                  + n_rows * (sizeof(Vector *) + MemoryForVector(n_cols));
   }

double MemoryEstimator::MemoryForIntArray(int size)
   {
   return sizeof(IntArray) + size * sizeof(int);
   }

double MemoryEstimator::MemoryForVector(int size)
   {
   return sizeof(Vector) + 8 * sizeof(char) + size * sizeof(double);
   }

double MemoryEstimator::MemoryForStringArray(int dim, int avg_string_len)
   {
   return sizeof(StringArray) + dim * (sizeof(String) + avg_string_len * sizeof(char));
   }

double MemoryEstimator::MemoryForStringMap(int dim, int avg_string_len)
   {
   return sizeof(StringMap) + dim * (sizeof(String) + avg_string_len * sizeof(char) + sizeof(int));
   }

double MemoryEstimator::MemoryForString(const String & string)
   {
   return sizeof(String) + string.Length() * sizeof(char);
   }

double MemoryEstimator::MemoryForString(const char * string)
   {
   return sizeof(String) + strlen(string) * sizeof(char);
   }

double MemoryEstimator::SpaceForString(const String & string)
   {
   return sizeof(char) * string.Length();
   }

double MemoryEstimator::SpaceForString(const char * string)
   {
   return sizeof(char) * strlen(string);
   }
 
 
 
