#include "PValue.h"
#include "StringBasics.h"
#include "MathConstant.h"

   //int digits_1 = p_all_combined < 1.5e-4 ? int(log(p_all_combined*0.06666666)*-0.4343) : 5;
   //int digits_2 = p_one_combined < 1.5e-4 ? int(log(p_one_combined*0.06666666)*-0.4343) : 5;


DoublePrint::DoublePrint()
   {
   }

DoublePrint::DoublePrint(double val,  int n_digits, double upper, double lower)
   {
   value = val;
   nDigits = n_digits;
   useScientific = val < upper && val > lower;
   MakePrintString();
   }

DoublePrint::DoublePrint(double val, int n_digits, bool use_scientific)
   {
   useScientific = use_scientific && val > 1e-200 && val < 1.0 - 1e-200;
   value = val;
   nDigits = n_digits;

   MakePrintString();
   }

void DoublePrint::MakePrintString()
   {
   formatString = useScientific ? "*%.*e" : "%.*f";
   output.printf((const char *) formatString, nDigits, value);
   }

PValue::PValue(double p, int min_digits, int max_digits, bool use_scientific)
   {
   value = p;
   nDigits = DetermineDigits(min_digits, max_digits, use_scientific);
   MakePrintString();
   }

PValue::PValue(double p, int min_digits, int max_digits, double scientific_cutoff)
   {
   value = p;
   useScientific = p < scientific_cutoff && p > 1e-100 && p < 1 - 1e-100 ;
   nDigits = DetermineDigits(min_digits, max_digits, useScientific );

   MakePrintString();
   }


/*
      bool use_scientific = p_hat < 0.00001 && p_hat > 0;
      int digits_1 = p_digits(p_hat, n_simulations, use_scientific);
      String message = ";
      message += use_scientific ? "%.*e\n" : "%.*f\n";

*/
int PValue::DetermineDigits(int min_digits, int max_digits, bool use_scientific)
   {
   // p-value of 1.0 or 0.0 printed with 1 digit
   if (value <  1e-50 || value >  1 - 1e-8) return 1;

   int digits = max(1, max_digits) - use_scientific * int(-log10(value) + 1);
   useScientific &= (value > 1e-50 && value < 1.0 - 1e-200);

   return min(digits, max_digits);
   }


 
 
 
